#include <cstdarg> // 'va_list' type
#include <cstdlib> // 'NULL'
#include <iostream>
#include <memory>

#include "Variable_number_of_arguments.h"

using namespace std;

Human_being::Human_being(int day_of_month, int month, int year) {
    _birth_date.tm_mday = day_of_month;
    _birth_date.tm_mon = month;
    _birth_date.tm_year = year;
}

int Human_being::age() const {
    time_t now = ::time(&now);
    // https://stackoverflow.com/questions/22450423/how-to-use-crt-secure-no-warnings:
    return ::gmtime(&now)->tm_year + 1900 - _birth_date.tm_year;
}

void Human_being::births(Human_being* child...) {
    va_list children;
    va_start(children, child);
    for (Human_being* e = child; e != NULL; e = va_arg(children, Human_being*)) _children.insert(e);
    va_end(children);
}

void Human_being::births(int nb, Human_being* child...) {
    va_list children;
    va_start(children, child);
    Human_being* e = child;
    for (int i = 0; i < nb; i++, e = va_arg(children, Human_being*)) _children.insert(e);
    va_end(children);
}

const Human_being Human_being::cloning() const {
    std::cout << "'cloning()' in 'Human_being' is called...\n";
    return *this;
}

const Man Man::cloning() const {
    std::cout << "'cloning()' in 'Man' is called...\n";
    return *this;
}

const Woman Woman::cloning() const {
    std::cout << "'cloning()' in 'Woman' is called...\n";
    return *this;
}

size_t Human_being::count() const {
    return _children.size();
}

void Human_being::insert(Human_being* child) {
    this->_children.insert(child);
};

int main(int argc, char** argv) {
    Human_being f(11, 01, 1963);
    int age = f.age();

    Human_being* man = new Man();
    Human_being clone = man->cloning(); // 'cloning()' in 'Human_being' is called...
    delete man;

    std::unique_ptr<Human_being> o = std::make_unique<Human_being>(6, 12, 1993);
    std::unique_ptr<Human_being> l = std::make_unique<Human_being>(15, 4, 1996);
    std::unique_ptr<Human_being> j = std::make_unique<Human_being>(22, 2, 2001);

    f.births(o.get(), l.get(), j.get(), NULL);
    f.births(3, o.get(), l.get(), j.get()); // Other method: no effect because of 'std::set'
    std::cout << "f: " << f.count() << std::endl;

    Human_being s(28, 07, 1964);
    // s.variadic_births(); // As expected, compilation error...
    s.variadic_births(o.get(), l.get(), j.get());
    std::cout << "s: " << s.count() << std::endl;
// As non-member function:
    variadic_template::births(s, o.get(), l.get(), j.get()); // No effect because of 'std::set'

    return 0;
}

